﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sencha.Direct
{
	static class CompilationOptions
	{
#if NET35
		public static readonly Version ForFrameworkVersion = new Version(3, 5);
#elif NET40
		public static readonly Version ForFrameworkVersion = new Version(4, 0);
#elif NET45
		public static readonly Version ForFrameworkVersion = new Version(4, 5);
#endif

#if STRICT
		public static readonly bool IsStrictToStandart = true;
#else
		public static readonly bool IsStrictToStandart = false;
#endif

#if DEBUG
		public static readonly bool ForDebug = true;
#else
		public static readonly bool ForDebug = false;
#endif

#if NO_TYPE_REFS
		public static readonly bool NoTypedReferences = true;
#else
		public static readonly bool NoTypedReferences = false;
#endif

#if FULL_TRUST
		public static readonly bool ForFullTrust = true;
#else
		public static readonly bool ForFullTrust = false;
#endif

#if CONTRACTS_FULL
		public static readonly bool WithCodeContracts = true;
#else
		public static readonly bool WithCodeContracts = false;
#endif

#if MVC2
		public readonly static Version WebPlatformVersion = new Version(2, 0);
#elif MVC3
		public readonly static Version WebPlatformVersion = new Version(3, 0);
#elif MVC4
		public readonly static Version WebPlatformVersion = new Version(4, 0);        
#else
		public readonly static Version WebPlatformVersion = new Version(0, 0);        
#endif

#if WEBAPI
		public readonly static bool IsWebApi = true;
#else
		public readonly static bool IsWebApi = false;
#endif

	}
}
