﻿using System;

namespace Sencha.Serialization.Bson
{
	[TypeSerializer(typeof(Serializers.BsonMinKeySerializer))]
    public sealed class BsonMinKey : IEquatable<BsonMinKey>
    {
		public static readonly BsonMinKey Value = new BsonMinKey();

        private BsonMinKey()
        {

        }

		#region IEquatable<BsonUndefined> Members

		public override bool Equals(object obj)
		{
			return (obj is BsonMinKey);
		}

		public override int GetHashCode()
		{
			return base.GetHashCode();
		}

		public bool Equals(BsonMinKey other)
		{
			return true;
		}

		#endregion

		public static bool operator ==(BsonMinKey a, BsonMinKey b)
		{
			if (ReferenceEquals(a, null) && ReferenceEquals(b, null))
				return false;
			else if (ReferenceEquals(a, null) || ReferenceEquals(b, null))
				return false;
			else
				return a.Equals(b);

		}
		public static bool operator !=(BsonMinKey a, BsonMinKey b)
		{
			return !(a == b);
		}

        public override string ToString()
        {
            return "minkey";
        }
    }
}
