﻿using System;

namespace Sencha.Serialization.Exceptions
{
	[Serializable]
	sealed class DiscriminatorValueAlreadyMapped : DataContractException
	{
		private Contracts.TypeDescription typeInfo;
		private string discriminatorValue;

		public DiscriminatorValueAlreadyMapped(Contracts.TypeDescription typeInfo, string discriminatorValue)
			: base(Loc.GetErrorString("Exception_DiscriminatorValueAlreadyMapped", typeInfo, discriminatorValue), ErrorCode.DiscriminatorValueAlreadyMapped)
		{

		}
		protected DiscriminatorValueAlreadyMapped(System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context)
			: base(info, context)
		{
		}
	}
}
