﻿using System;

namespace Sencha.Serialization.Exceptions
{
	[Serializable]
	sealed class UnmappedDiscriminatorValue : DataContractException
	{
		public UnmappedDiscriminatorValue(Contracts.TypeDescription discriminatedType, Contracts.MemberDescription discriminatorMember, string discriminatorValue)
			: base(Loc.GetErrorString("Exception_UnmappedDiscriminatorValue", discriminatedType, discriminatorMember, discriminatorValue), ErrorCode.UnmappedDiscriminatorValue)
		{
		}
		protected UnmappedDiscriminatorValue(System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context)
			: base(info, context)
		{
		}
	}
}
