﻿using Sencha.Serialization.Contracts;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Sencha.Serialization.Tests
{


	/// <summary>
	///This is a test class for DataContractCacheTest and is intended
	///to contain all DataContractCacheTest Unit Tests
	///</summary>
	[TestClass()]
	public class DataContractCacheTest
	{

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for Cache
		///</summary>
		[TestMethod()]
		public void PutInCache()
		{
			object cacheKey = new object();
			DataContract contract = new DataContract(typeof(ConsoleColor));
			DataContractCache.PutInCache(cacheKey, contract);

			var expected = contract;
			var actual = DataContractCache.FetchFromCache(cacheKey);

			Assert.IsNotNull(actual);
			Assert.AreSame(expected, actual);
		}

		/// <summary>
		///A test for RetrieveFromCache
		///</summary>
		[TestMethod()]
		public void FetchFromCache()
		{
			object cacheKey = new object();
			DataContract expected = null;
			DataContract actual;
			actual = DataContractCache.FetchFromCache(cacheKey);
			Assert.AreSame(expected, actual);
		}


		/// <summary>
		///A test for FetchOrCreate
		///</summary>
		[TestMethod()]
		public void FetchOrCreate()
		{
			object cacheKey = new object();
			DataContract expected = DataContractCache.DefaultContract;
			DataContract actual;
			Func<DataContract> creator = (() => DataContractCache.DefaultContract);
			actual = DataContractCache.FetchOrCreate(cacheKey, creator);
			Assert.AreSame(expected, actual);
		}

		/// <summary>
		///A test for DefaultContract
		///</summary>
		[TestMethod()]
		public void DefaultContractTest()
		{
			DataContract actual;
			actual = DataContractCache.DefaultContract;
			Assert.IsNotNull(actual);
		}

		/// <summary>
		///A test for DefaultContract
		///</summary>
		[TestMethod()]
		public void AdHocContractTest()
		{
			DataContract actual;
			actual = DataContractCache.AdHocContract;
			Assert.IsNotNull(actual);
		}
	}
}
