﻿using System;
using System.Collections.Generic;

namespace Sencha.Serialization.Tests
{
	public class VersionSerializer : TypeSerializer<Version>
	{
		public override Version Deserialize(IJsonReader reader)
		{
			var versionString = reader.ReadString();
			if (versionString == null)
				return null;
			else
				return new Version(versionString);
		}

		public override void Serialize(IJsonWriter writer, Version value)
		{
			if (value == null)
				writer.WriteNull();
			else
				writer.WriteString(value.ToString());
		}
	}
}
