﻿using Sencha.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;

namespace Sencha.Serialization.Tests
{
    
    
    /// <summary>
    ///This is a test class for JsonStringBuilderReaderTest and is intended
    ///to contain all JsonStringBuilderReaderTest Unit Tests
    ///</summary>
	[TestClass()]
	public class JsonStringBuilderReaderTest
	{


		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for JsonStringBuilderReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringBuilderReaderConstructorTest()
		{
			StringBuilder str = new StringBuilder("23");
			ISerializationContext context = new AdHocSerializer();
			int bufferSize = 1024; 
			JsonStringBuilderReader target = new JsonStringBuilderReader(str, context, bufferSize);
		}

		/// <summary>
		///A test for JsonStringBuilderReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringBuilderReaderConstructorTest1()
		{
			StringBuilder str = new StringBuilder("123213");
			int bufferSize = 1024; 
			JsonStringBuilderReader target = new JsonStringBuilderReader(str, bufferSize);
		}

		/// <summary>
		///A test for JsonStringBuilderReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringBuilderReaderConstructorTest2()
		{
			var str = new StringBuilder("123213");
			JsonStringBuilderReader target = new JsonStringBuilderReader(str);
		}

		/// <summary>
		///A test for FillBuffer
		///</summary>
		[TestMethod()]
		[DeploymentItem("Sencha.Serialization.dll")]
		public void FillBufferTest()
		{
			var testString = new StringBuilder("here is my test string");
			var reader = new JsonStringBuilderReader(testString);
			var target = new JsonStringBuilderReader_Accessor(new PrivateObject(reader));
			char[] buffer = new char[1024];
			int index = 564;
			int expected = index + testString.Length;
			char[] expectedChars = testString.ToString().ToCharArray();
			int actual;
			actual = target.FillBuffer(buffer, index);
			Assert.AreEqual(expected, actual);

			for (var i = index; i < expectedChars.Length; i++)
				Assert.AreEqual(expectedChars[i - index], buffer[i], "wrong character copied in buffer");
		}

		/// <summary>
		///A test for JsonStreamReader Constructor
		///</summary>
		[TestMethod()]
		public void ToStringTest()
		{
			var target = new JsonStringBuilderReader(new StringBuilder());
			Assert.IsNotNull(target.ToString());
		}
	}
}
