﻿using Sencha.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;

namespace Sencha.Serialization.Tests
{
    
    
    /// <summary>
    ///This is a test class for JsonStringBuilderWriterTest and is intended
    ///to contain all JsonStringBuilderWriterTest Unit Tests
    ///</summary>
	[TestClass()]
	public class JsonStringBuilderWriterTest
	{
		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for JsonStringBuilderWriter Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringBuilderWriterConstructorTest()
		{
			StringBuilder builder = new StringBuilder();
			ISerializationContext context = new AdHocSerializer();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder, context);
		}

		/// <summary>
		///A test for JsonStringBuilderWriter Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringBuilderWriterConstructorTest1()
		{
			StringBuilder builder = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder);
		}

		/// <summary>
		///A test for Flush
		///</summary>
		[TestMethod()]
		public void FlushTest()
		{
			StringBuilder builder = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder);

			target.WriteJson("myJson");

			var position = builder.Length;

			target.Flush();

			position = builder.Length;

			Assert.AreNotEqual(0, position);
		}

		/// <summary>
		///A test for ToString
		///</summary>
		[TestMethod()]
		public void ToStringTest()
		{
			var stream = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(stream);

			Assert.IsNotNull(target.ToString());
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteJsonTest()
		{
			StringBuilder builder = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder);

			string jsonString = "My arbitary json";
			target.WriteJson(jsonString);
			target.Flush();

			var position = builder.Length;

			Assert.AreNotEqual(0, position);
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteEmptyJsonTest()
		{
			StringBuilder builder = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder);

			string jsonString = String.Empty;
			target.WriteJson(jsonString);
			target.Flush();

			var position = builder.Length;

			Assert.AreEqual(0, position);
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteJsonTestWithCharArray()
		{
			StringBuilder builder = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder);

			char[] jsonString = "My arbitary json".ToCharArray();
			int len = 7;
			int index = 1;
			target.WriteJson(jsonString, index, len);
			target.Flush();

			var position = builder.Length - 1;

			Assert.AreEqual(len - index, position);
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteEmptyJsonTestWithCharArray()
		{
			StringBuilder builder = new StringBuilder();
			JsonStringBuilderWriter target = new JsonStringBuilderWriter(builder);

			char[] jsonString = "My arbitary json".ToCharArray();
			int len = 0;
			int index = 1;
			target.WriteJson(jsonString, index, len);
			target.Flush();

			var position = builder.Length;

			Assert.AreEqual(len, position);
		}
	}
}
