﻿using Sencha.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Sencha.Serialization.Tests
{
    
    
    /// <summary>
    ///This is a test class for JsonStringReaderTest and is intended
    ///to contain all JsonStringReaderTest Unit Tests
    ///</summary>
	[TestClass()]
	public class JsonStringReaderTest
	{


		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for JsonStringReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringReaderConstructorTest()
		{
			string str = "123123";
			ISerializationContext context = new AdHocSerializer();
			int bufferSize = 10;
			JsonStringReader target = new JsonStringReader(str, context, bufferSize);
		}

		/// <summary>
		///A test for JsonStringReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringReaderConstructorTest1()
		{
			string str = "sadasd";
			int bufferSize = 10; // TODO: Initialize to an appropriate value
			JsonStringReader target = new JsonStringReader(str, bufferSize);
		}

		/// <summary>
		///A test for JsonStringReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonStringReaderConstructorTest2()
		{
			string str = "213213";
			JsonStringReader target = new JsonStringReader(str);
		}

		/// <summary>
		///A test for FillBuffer
		///</summary>
		[TestMethod()]
		[DeploymentItem("Sencha.Serialization.dll")]
		public void FillBufferTest()
		{
			var testString = ("here is my test string");
			var reader = new JsonStringReader(testString);
			var target = new JsonStringReader_Accessor(new PrivateObject(reader));
			char[] buffer = new char[1024];
			int index = 10;
			int expected = index + testString.Length;
			char[] expectedChars = testString.ToCharArray();
			int actual;
			actual = target.FillBuffer(buffer, index);
			Assert.AreEqual(expected, actual);

			for (var i = index; i < expectedChars.Length; i++)
				Assert.AreEqual(expectedChars[i - index], buffer[i], "wrong character copied in buffer");
		}

		/// <summary>
		///A test for JsonStreamReader Constructor
		///</summary>
		[TestMethod()]
		public void ToStringTest()
		{
			var target = new JsonStringReader("213123");
			Assert.IsNotNull(target.ToString());
		}
	}
}
