﻿using Sencha.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.IO;

namespace Sencha.Serialization.Tests
{


	/// <summary>
	///This is a test class for JsonTextReaderTest and is intended
	///to contain all JsonTextReaderTest Unit Tests
	///</summary>
	[TestClass()]
	public class JsonTextReaderTest
	{


		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for JsonTextReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonTextReaderConstructorTest()
		{
			TextReader reader = new StringReader("123123");
			ISerializationContext context = new AdHocSerializer();
			int bufferSize = 110; 
			JsonTextReader target = new JsonTextReader(reader, context, bufferSize);
		}

		/// <summary>
		///A test for JsonTextReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonTextReaderConstructorTest1()
		{
			TextReader reader = new StringReader("123123");
			int bufferSize = 10; 
			JsonTextReader target = new JsonTextReader(reader, bufferSize);
		}

		/// <summary>
		///A test for JsonTextReader Constructor
		///</summary>
		[TestMethod()]
		public void JsonTextReaderConstructorTest2()
		{
			TextReader reader = new StringReader("123123");
			JsonTextReader target = new JsonTextReader(reader);
		}

		/// <summary>
		///A test for FillBuffer
		///</summary>
		[TestMethod()]
		[DeploymentItem("Sencha.Serialization.dll")]
		public void FillBufferTest()
		{
			var testString = ("here is my test string");
			var reader = new JsonTextReader(new StringReader(testString));
			var target = new JsonTextReader_Accessor(new PrivateObject(reader));
			char[] buffer = new char[1024];
			int index = 10;
			int expected = index + testString.Length;
			char[] expectedChars = testString.ToCharArray();
			int actual;
			actual = target.FillBuffer(buffer, index);
			Assert.AreEqual(expected, actual);

			for (var i = index; i < expectedChars.Length; i++)
				Assert.AreEqual(expectedChars[i - index], buffer[i], "wrong character copied in buffer");
		}

		/// <summary>
		///A test for JsonStreamReader Constructor
		///</summary>
		[TestMethod()]
		public void ToStringTest()
		{
			var target = new JsonTextReader(new StringReader("213123"));
			Assert.IsNotNull(target.ToString());
		}
	}
}
