﻿using Sencha.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.IO;
using System.Text;

namespace Sencha.Serialization.Tests
{


	/// <summary>
	///This is a test class for JsonTextWriterTest and is intended
	///to contain all JsonTextWriterTest Unit Tests
	///</summary>
	[TestClass()]
	public class JsonTextWriterTest
	{


		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for JsonTextWriter Constructor
		///</summary>
		[TestMethod()]
		public void JsonTextWriterConstructorTest()
		{
			TextWriter writer = new StringWriter();
			ISerializationContext context = new AdHocSerializer();
			JsonTextWriter target = new JsonTextWriter(writer, context);
		}

		/// <summary>
		///A test for JsonTextWriter Constructor
		///</summary>
		[TestMethod()]
		public void JsonTextWriterConstructorTest1()
		{
			TextWriter writer = new StringWriter();
			JsonTextWriter target = new JsonTextWriter(writer);
		}

		/// <summary>
		///A test for Flush
		///</summary>
		[TestMethod()]
		public void FlushTest()
		{
			var stream = new StringBuilder();
			TextWriter writer = new StringWriter(stream);
			JsonTextWriter target = new JsonTextWriter(writer);

			target.WriteJson("myJson");

			var position = stream.Length;

			target.Flush();

			position = stream.Length;

			Assert.AreNotEqual(0, position);
		}

		/// <summary>
		///A test for ToString
		///</summary>
		[TestMethod()]
		public void ToStringTest()
		{
			var stream = new StringBuilder();
			TextWriter writer = new StringWriter(stream);
			JsonTextWriter target = new JsonTextWriter(writer);

			Assert.IsNotNull(target.ToString());
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteJsonTest()
		{
			var stream = new StringBuilder();
			TextWriter writer = new StringWriter(stream);
			JsonTextWriter target = new JsonTextWriter(writer);

			string jsonString = "My arbitary json";
			target.WriteJson(jsonString);
			target.Flush();

			var position = stream.Length;

			Assert.AreNotEqual(0, position);
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteEmptyJsonTest()
		{
			var stream = new StringBuilder();
			TextWriter writer = new StringWriter(stream);
			JsonTextWriter target = new JsonTextWriter(writer);

			string jsonString = String.Empty;
			target.WriteJson(jsonString);
			target.Flush();

			var position = stream.Length;

			Assert.AreEqual(0, position);
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteJsonTestWithCharArray()
		{
			var stream = new StringBuilder();
			TextWriter writer = new StringWriter(stream);
			JsonTextWriter target = new JsonTextWriter(writer);
			
			char[] jsonString = "My arbitary json".ToCharArray();
			int len = 7;
			int index = 1;
			target.WriteJson(jsonString, index, len);
			target.Flush();

			var position = stream.Length - 1;

			Assert.AreEqual(len - index, position);
		}

		/// <summary>
		///A test for WriteJson
		///</summary>
		[TestMethod()]
		public void WriteEmptyJsonTestWithCharArray()
		{
			var stream = new StringBuilder();
			TextWriter writer = new StringWriter(stream);
			JsonTextWriter target = new JsonTextWriter(writer);

			char[] jsonString = "My arbitary json".ToCharArray();
			int len = 0;
			int index = 1;
			target.WriteJson(jsonString, index, len);
			target.Flush();

			var position = stream.Length;

			Assert.AreEqual(len, position);
		}
	}
}
