﻿using System;
using System.Collections.Generic;

namespace Sencha.Serialization.Tests.Test_Data
{
	public class ReadWriteTestObject : IEquatable<ReadWriteTestObject>
	{
		public byte ByteField = 1;
		public sbyte SByteField = 2;
		public Int16 Int16Field = 3;
		public UInt16 UInt16Field = 4;
		public Int32 Int32Field = 5;
		public UInt32 UInt32Field = 6;
		public Int64 Int64Field = 7;
		public UInt64 UInt64Field = 8;
		public Decimal DecimalField = 9;
		public Single SingleFiled = 10;
		public Double DoubleField = 11;
		public String StringField = "12";
		public ConsoleColor MyEnumField = ConsoleColor.Cyan;
		public bool BooleanField = true;
		public DateTime DateTimeField = DateTime.UtcNow;
		public DateTimeOffset DateTimeOffsetField = DateTime.UtcNow;
		public Guid GuidField = Guid.NewGuid();
		public TimeSpan TimeSpanField = TimeSpan.FromHours(12.3);
		public Uri UrlField = new Uri("http://sample.com/fr.ttt?hello=world");
		public string NullField = null;
		public int[] IntArrayField = new int[] { 1, 2, 3 };
		public string[] StringArrayField = new string[] { "1", "2" };
		public int[] EmptyArrayField = new int[0];
		public int[] NullArrayField = null;
		public Dictionary<string, object> DictionaryArrayField = new Dictionary<string, object> { { "a", 0 }, { "b", "c" } };
		public object[] ObjectArrayField = new object[] { new object[] { new object() } };

		public override bool Equals(object obj)
		{
			var other = obj as ReadWriteTestObject;
			return this.Equals(other);
		}

		#region IEquatable<ReadWriteTestObject> Members

		public bool Equals(ReadWriteTestObject other)
		{
			if (other == null)
				return false;

			return this.ByteField == other.ByteField &&
			this.SByteField == other.SByteField &&
			this.Int16Field == other.Int16Field &&
			this.UInt16Field == other.UInt16Field &&
			this.Int32Field == other.Int32Field &&
			this.UInt32Field == other.UInt32Field &&
			this.Int64Field == other.Int64Field &&
			this.UInt64Field == other.UInt64Field &&
			this.DecimalField == other.DecimalField &&
			this.SingleFiled == other.SingleFiled &&
			this.DoubleField == other.DoubleField &&
			this.StringField == other.StringField &&
			this.MyEnumField == other.MyEnumField &&
			this.BooleanField == other.BooleanField &&
			new TimeSpan(Math.Abs((this.DateTimeField - other.DateTimeField).Ticks)) < TimeSpan.FromSeconds(1) &&
			new TimeSpan(Math.Abs((this.DateTimeOffsetField - other.DateTimeOffsetField).Ticks)) < TimeSpan.FromSeconds(1) &&
			this.GuidField == other.GuidField &&
			this.TimeSpanField == other.TimeSpanField &&
			this.UrlField.Equals(other.UrlField) &&
			this.NullField == other.NullField &&
			this.IntArrayField.Length == other.IntArrayField.Length &&
			this.StringArrayField.Length == other.StringArrayField.Length &&
			this.EmptyArrayField.Length == other.EmptyArrayField.Length &&
			this.NullArrayField == other.NullArrayField &&
			this.DictionaryArrayField.Count == other.DictionaryArrayField.Count &&
			this.ObjectArrayField.Length == other.ObjectArrayField.Length;
		}

		#endregion
	}
}
