﻿using Sencha.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;

namespace Sencha.Serialization.Tests
{
    
    
    /// <summary>
    ///This is a test class for ReflectionExtentionsTest and is intended
    ///to contain all ReflectionExtentionsTest Unit Tests
    ///</summary>
	[TestClass()]
	public class ReflectionExtentionsTest
	{
		public class MyDictionary : Dictionary<string, object>
		{

		}

		public class TestList : IEnumerable<bool>, IList<byte>
		{

			#region IEnumerable<bool> Members

			public IEnumerator<bool> GetEnumerator()
			{
				throw new NotImplementedException();
			}

			#endregion

			#region IEnumerable Members

			System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
			{
				throw new NotImplementedException();
			}

			#endregion

			#region IList<byte> Members

			public int IndexOf(byte item)
			{
				throw new NotImplementedException();
			}

			public void Insert(int index, byte item)
			{
				throw new NotImplementedException();
			}

			public void RemoveAt(int index)
			{
				throw new NotImplementedException();
			}

			public byte this[int index]
			{
				get
				{
					throw new NotImplementedException();
				}
				set
				{
					throw new NotImplementedException();
				}
			}

			#endregion

			#region ICollection<byte> Members

			public void Add(byte item)
			{
				throw new NotImplementedException();
			}

			public void Clear()
			{
				throw new NotImplementedException();
			}

			public bool Contains(byte item)
			{
				throw new NotImplementedException();
			}

			public void CopyTo(byte[] array, int arrayIndex)
			{
				throw new NotImplementedException();
			}

			public int Count
			{
				get { throw new NotImplementedException(); }
			}

			public bool IsReadOnly
			{
				get { throw new NotImplementedException(); }
			}

			public bool Remove(byte item)
			{
				throw new NotImplementedException();
			}

			#endregion

			#region IEnumerable<byte> Members

			IEnumerator<byte> IEnumerable<byte>.GetEnumerator()
			{
				throw new NotImplementedException();
			}

			#endregion
		}

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}


		/// <summary>
		///A test for IsInstantiationOf
		///</summary>
		[TestMethod()]
		public void IsInstantiationOfIEnumerableTest()
		{
			Type competedGenericType = typeof(List<string>);
			Type openGenericType = typeof(IEnumerable<>);
			bool expected = true;
			bool actual;
			actual = ReflectionExtentions.IsInstantiationOf(competedGenericType, openGenericType);
			Assert.AreEqual(expected, actual);
		}

		/// <summary>
		///A test for IsInstantiationOf
		///</summary>
		[TestMethod()]
		public void IsInstantiationOfListTest()
		{
			Type competedGenericType = typeof(List<string>);
			Type openGenericType = typeof(List<>);
			bool expected = true;
			bool actual;
			actual = ReflectionExtentions.IsInstantiationOf(competedGenericType, openGenericType);
			Assert.AreEqual(expected, actual);
		}


		/// <summary>
		///A test for IsInstantiationOf
		///</summary>
		[TestMethod()]
		public void IsInstantiationOfIDictionaryTest()
		{
			Type competedGenericType = typeof(Dictionary<string, object>);
			Type openGenericType = typeof(IDictionary<,>);
			bool expected = true;
			bool actual;
			actual = ReflectionExtentions.IsInstantiationOf(competedGenericType, openGenericType);
			Assert.AreEqual(expected, actual);
		}


		/// <summary>
		///A test for IsInstantiationOf
		///</summary>
		[TestMethod()]
		public void IsInstantiationOfInheritedGenericClassTest()
		{
			Type competedGenericType = typeof(MyDictionary);
			Type openGenericType = typeof(Dictionary<,>);
			bool expected = true;
			bool actual;
			actual = ReflectionExtentions.IsInstantiationOf(competedGenericType, openGenericType);
			Assert.AreEqual(expected, actual);
		}

		/// <summary>
		///A test for IsInstantiationOf
		///</summary>
		[TestMethod()]
		public void IsInstantiationOfInheritedGenericInterfaceTest()
		{
			Type competedGenericType = typeof(MyDictionary);
			Type openGenericType = typeof(IDictionary<,>);
			bool expected = true;
			bool actual;
			actual = ReflectionExtentions.IsInstantiationOf(competedGenericType, openGenericType);
			Assert.AreEqual(expected, actual);
		}

		/// <summary>
		///A test for IsInstantiationOf
		///</summary>
		[TestMethod()]
		public void GetInstantiationArgumentsTest()
		{
			Type competedGenericType = typeof(MyDictionary);
			Type openGenericType = typeof(IDictionary<,>);
			var expected = new Type[] { typeof(string), typeof(object) };
			var actual = ReflectionExtentions.GetInstantiationArguments(competedGenericType, openGenericType);
			
			Assert.AreEqual(expected.Length, actual.Length);
			Assert.AreEqual(expected[0], actual[0]);
			Assert.AreEqual(expected[1], actual[1]);
		}

		/// <summary>
		///A test for HasMultipleInstantiations
		///</summary>
		[TestMethod()]
		public void HasMultipleInstantiationsTest()
		{
			Type competedGenericType = typeof(TestList);
			Type openGenericType = typeof(IEnumerable<>);
			var expected = true;
			var actual = ReflectionExtentions.HasMultipleInstantiations(competedGenericType, openGenericType);

			Assert.AreEqual(expected, actual);
		}

		/// <summary>
		///A test for HasMultipleInstantiations
		///</summary>
		[TestMethod()]
		public void HasMultipleInstantiationsNegativeTest()
		{
			Type competedGenericType = typeof(TestList);
			Type openGenericType = typeof(IList<>);
			var expected = false;
			var actual = ReflectionExtentions.HasMultipleInstantiations(competedGenericType, openGenericType);

			Assert.AreEqual(expected, actual);
		}
	}
}
