﻿using System;
using Sencha.Serialization.Bson;

namespace Serialization.Serialization.IntegrationTests
{
	public class TestClassA
	{
		public int IntProp { get; set; }
		public long LongProp { get; set; }
		public bool BoolField { get; set; }
		public string StringField { get; set; }
		public double DoubleField { get; set; }
		public BsonBinary GuidField { get; set; }
		public BsonRegex RegexField { get; set; }
		public BsonBinary ByteArrayField { get; set; }
		public BsonObjectId ObjectIdField { get; set; }
		public BsonJavaScriptWithScope ScopedCodeField { get; set; }
		public TestClassA AClassRef { get; set; }
		public TestClassD DClassRef { get; set; }

		public int[] IntArrayProp { get; set; }
		public string[] StringArrayProp { get; set; }
		public TestClassB[] ClassBArray { get; set; }

		public static TestClassA CreateTestClass()
		{
			var classA = new TestClassA
			{
				BoolField = true,
				DoubleField = -1.0,
				GuidField = new BsonBinary(new Guid(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11)),
				IntProp = int.MinValue,
				LongProp = long.MinValue,
				RegexField = new BsonRegex("mypatternАГА", "elu"),
				ObjectIdField = BsonObjectId.Parse("04030201080706050c0b0a09"),
				ScopedCodeField = new BsonJavaScriptWithScope("MY ARBITARYCODE STRING", new System.Collections.Hashtable { { "ObjectIdField", BsonObjectId.Parse("04030201080706050c0b0a09") } }),
				StringField = "Моя с\0трокаЕпта",
				AClassRef = new TestClassA()
				{
					DoubleField = double.MaxValue,
					IntProp = int.MinValue,
					LongProp = int.MaxValue,
					GuidField = new BsonBinary(new byte[16]),
					BoolField = false,
					ObjectIdField = new BsonObjectId(),
					DClassRef = new TestClassD { StringField = "string" }
				},
				DClassRef = new TestClassD
				{
					StringField = "MYSTIRNG\0\b\r\n\0"
				},
				ByteArrayField = new BsonBinary(new byte[] { 1, 2, 3, 4, 5 }),
				StringArrayProp = new string[] { "1", "2", "3", "4", "5", "6" },
				ClassBArray = new TestClassB[] { new TestClassB { ObjectIdField = new BsonObjectId() }, new TestClassB { ObjectIdField = new BsonObjectId() } },
				IntArrayProp = new int[] { 0, 9, 8, 7, 6, 5, 4, 3, 2, 1 }
			};

			return classA;
		}
	}
	public class TestClassB
	{
		public BsonObjectId ObjectIdField { get; set; }
	}
	public class TestClassD
	{
		public string StringField { get; set; }
	}
}
