﻿using System;
using System.IO;

namespace Serialization.Serialization.IntegrationTests
{
	class NullStream : Stream
	{
		private long m_length;

		public override bool CanRead
		{
			get { return true; }
		}

		public override bool CanSeek
		{
			get { return false; }
		}

		public override bool CanWrite
		{
			get {  return true; }
		}

		public override void Flush()
		{
			
		}

		public override long Length
		{
			get { return m_length; }
		}

		public override long Position
		{
			get
			{
				return m_length;
			}
			set
			{
				throw new NotSupportedException();
			}
		}

		public override int Read(byte[] buffer, int offset, int count)
		{
			return count;
		}

		public override long Seek(long offset, SeekOrigin origin)
		{
			throw new NotSupportedException();
		}

		public override void SetLength(long value)
		{
			m_length = value;
		}

		public override void Write(byte[] buffer, int offset, int count)
		{
			m_length += count;
		}

		protected override void Dispose(bool disposing)
		{
			
		}
	}
}
