﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace Serialization.Serialization.IntegrationTests
{
	class Program
	{
		static void Main(string[] args)
		{
			BasicReadWrite();
			ComplexReadWrite();
			//CASReadWrite();
			ScaledReadWrite();
		}		
		private static void BasicReadWrite()
		{
			ReadJson.FromStream(new byte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new short[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new long[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new sbyte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new ushort[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new uint[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new ulong[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 }, "BasicIntArray.js");
			ReadJson.FromStream(new string[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "14" }, "BasicStringArray.js");
			ReadJson.FromStream(new Dictionary<int, int> { { 1, 2 }, { 3, 4 }, { 5, 6 }, { 7, 8 }, { 9, 10 } }, "BasicIntIntDictionary.js");
			ReadJson.FromStream(new Dictionary<int, byte> { { 1, 2 }, { 3, 4 }, { 5, 6 }, { 7, 8 }, { 9, 10 } }, "BasicIntIntDictionary.js");
			ReadJson.FromStream(new Dictionary<byte, int> { { 1, 2 }, { 3, 4 }, { 5, 6 }, { 7, 8 }, { 9, 10 } }, "BasicIntIntDictionary.js");
			ReadJson.FromStream(new Dictionary<int, string> { { 1, "str2" }, { 3, "str4" }, { 5, "str6" }, { 7, "str8" }, { 9, "str10" } }, "BasicIntStringDictionary.js");
			ReadJson.FromStream(new Dictionary<string, string> { { "a1", "str2" }, { "b3", "str4" }, { "c5", "str6" }, { "d7", "str8" }, { "e9", "str10" } }, "BasicStringStringDictionary.js");
			ReadJson.FromStream(new Dictionary<string, string> { { "a1", "str2" }, { "b3", "str4" }, { "c5", "str6" }, { "d7", "str8" }, { "e9", "str10" } }, "BasicStringStringDictionary.js");
			ReadJson.FromStream(new Hashtable { { "a1", "str2" }, { "b3", "str4" }, { "c5", "str6" }, { "d7", "str8" }, { "e9", "str10" } }, "BasicStringStringDictionary.js");
			ReadJson.FromStream(new KeyValue<Int32, String>(1, "str"), "BasicKeyValue.js");

			WriteJson.ToNullStream(new byte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new short[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new long[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new sbyte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new ushort[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new uint[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new ulong[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14 });
			WriteJson.ToNullStream(new string[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "14" });
			WriteJson.ToNullStream(new Dictionary<int, int> { { 1, 2 }, { 3, 4 }, { 5, 6 }, { 7, 8 }, { 9, 10 } });
			WriteJson.ToNullStream(new Dictionary<int, byte> { { 1, 2 }, { 3, 4 }, { 5, 6 }, { 7, 8 }, { 9, 10 } });
			WriteJson.ToNullStream(new Dictionary<byte, int> { { 1, 2 }, { 3, 4 }, { 5, 6 }, { 7, 8 }, { 9, 10 } });
			WriteJson.ToNullStream(new Dictionary<int, string> { { 1, "str2" }, { 3, "str4" }, { 5, "str6" }, { 7, "str8" }, { 9, "str10" } });
			WriteJson.ToNullStream(new Dictionary<string, string> { { "a1", "str2" }, { "b3", "str4" }, { "c5", "str6" }, { "d7", "str8" }, { "e9", "str10" } });
			WriteJson.ToNullStream(new KeyValue<Int32, String>(1, "str"));
		}
		private static void ComplexReadWrite()
		{
			ReadJson.FromStream(new BigPlainObject(true), "BigPlainObject.js");
			WriteJson.ToNullStream(new BigPlainObject(true));
		}
		private static void CASReadWrite()
		{
			WriteJson.ToNullStream(new { a = 1, b = "", c = new DateTime(), d = new { a = 1, b = 3, c = new[] { "a", "v" } } });

			var privateObj = new PrivateObject(true);
			WriteJson.ToNullStream(privateObj);
		}
		private static void ScaledReadWrite()
		{
			var maxObj = (long)100;
			var bigPlainObject = new BigPlainObject((int)(1232323313), 1, ref maxObj);
			maxObj = 100 - maxObj;
			// warmup
			WriteJson.ToNullStream(bigPlainObject);
			//

			for (var i = 1; i < 4; i++)
			{				
				var repeats = 10 * (int)Math.Pow(10, i);
				
				var repeat = Repeat(bigPlainObject, repeats);				
				var sw = new System.Diagnostics.Stopwatch();
				sw.Start();
				var size = WriteJson.ToNullStream(repeat);
				sw.Stop();
				Console.WriteLine("A ~{0} objects written in {1}ms at {2:##,#}kb file", maxObj * repeats, sw.ElapsedMilliseconds, size / 1024);
			}
		}

		private static IEnumerable<T> Repeat<T>(T value, int count)
		{
			for (int i = 0; i < count; i++)
				yield return value;
		}
	}
}
