﻿using System;
using Sencha.Serialization.Contracts;
using Sencha.Serialization;
using System.IO;


namespace Serialization.Serialization.IntegrationTests
{
	class WriteJson
	{
		public static long ToFile<T>(T value, string filePath)
		{
			var serializableType = typeof(T);
			var interpreter = MetadataInterpreter.DataContract;
			var descriptor = MetadataDescriber.ReflectionPublicOnly;
			var contract = new DataContract(serializableType, interpreter, descriptor);
			var target = new JsonSerializer(contract) { IgnoreCustomSerialization = false, SerializeByteArrayAsBase64 = true, SerializeEnumsAsInteger = false, SkipUnaccessibleMembers = true, SkipUnknownMember = true, StringInterchange = true, ArrayInterchange = true };
			using (var fileStream = File.OpenWrite(filePath))
			{
				target.WriteObject<T>(fileStream, value);
				return fileStream.Length;
			}
		}
		public static long ToNullStream<T>(T value)
		{
			var serializableType = typeof(T);
			var interpreter = MetadataInterpreter.DataContract;
			var descriptor = MetadataDescriber.ReflectionPublicOnly;
			var contract = new DataContract(serializableType, interpreter, descriptor);
			var target = new JsonSerializer(contract) { IgnoreCustomSerialization = false, SerializeByteArrayAsBase64 = true, SerializeEnumsAsInteger = false, SkipUnaccessibleMembers = true, SkipUnknownMember = true, StringInterchange = true, ArrayInterchange = true };
			using (var nullStream = new NullStream())
			{

				target.WriteObject(nullStream, value);
				return nullStream.Length;
			}
		}

		public static long ToOutputStream<T>(T value)
		{
			var serializableType = typeof(T);
			var interpreter = MetadataInterpreter.DataContract;
			var descriptor = MetadataDescriber.ReflectionPublicOnly;
			var contract = new DataContract(serializableType, interpreter, descriptor);
			var target = new JsonSerializer(contract) { IgnoreCustomSerialization = false, SerializeByteArrayAsBase64 = true, SerializeEnumsAsInteger = false, SkipUnaccessibleMembers = true, SkipUnknownMember = true, StringInterchange = true, ArrayInterchange = true };

			target.WriteObject(Console.Out, value);

			return 0;
		}
	}

}
